/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Heap.xs. Do not edit this file, edit Heap.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Heap.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* pre-5.10 compatibility */
#ifndef GV_NOTQUAL
# define GV_NOTQUAL 1
#endif
#ifndef gv_fetchpvs
# define gv_fetchpvs gv_fetchpv
#endif

/* pre-5.8 compatibility */
#ifndef PERL_MAGIC_tied
# define PERL_MAGIC_tied 'P'
#endif

#include "multicall.h"

/* workaround for buggy multicall API */
#ifndef cxinc
# define cxinc() Perl_cxinc (aTHX)
#endif

#define dCMP			\
  dMULTICALL;			\
  void *cmp_data;               \
  I32 gimme = G_SCALAR;

#define CMP_PUSH(sv)		\
  PUSH_MULTICALL (cmp_push_ (sv));\
  cmp_data = multicall_cop;

#define CMP_POP			\
  POP_MULTICALL;

#define dCMP_CALL(data)		\
  OP *multicall_cop = (OP *)data;

static void *
cmp_push_ (SV *sv)
{
  HV *st;
  GV *gvp;
  CV *cv;

  cv = sv_2cv (sv, &st, &gvp, 0);

  if (!cv)
    croak ("%s: callback must be a CODE reference or another callable object", SvPV_nolen (sv));

  SAVESPTR (PL_firstgv ); PL_firstgv  = gv_fetchpv ("a", GV_ADD | GV_NOTQUAL, SVt_PV); SAVESPTR (GvSV (PL_firstgv ));
  SAVESPTR (PL_secondgv); PL_secondgv = gv_fetchpv ("b", GV_ADD | GV_NOTQUAL, SVt_PV); SAVESPTR (GvSV (PL_secondgv));

  return cv;
}

/*****************************************************************************/

static SV *
sv_first (SV *sv)
{
  if (SvROK (sv) && SvTYPE (SvRV (sv)) == SVt_PVAV)
    {
      AV *av = (AV *)SvRV (sv);

      sv = AvFILLp (av) < 0 || !AvARRAY (sv)[0]
           ? &PL_sv_undef : AvARRAY (av)[0];
    }

  return sv;
}

static void
set_idx (SV *sv, int idx)
{
  if (!SvROK (sv))
    return;

  sv = SvRV (sv);
  
  if (SvTYPE (sv) != SVt_PVAV)
    return;
  
  if (
     AvFILL ((AV *)sv) < 1
     || AvARRAY ((AV *)sv)[1] == 0
     || AvARRAY ((AV *)sv)[1] == &PL_sv_undef)
    av_store ((AV *)sv, 1, newSViv (idx));
  else
    {
      sv = AvARRAY ((AV *)sv)[1];

      if (SvTYPE (sv) == SVt_IV)
        SvIV_set (sv, idx);
      else
        sv_setiv (sv, idx);
    }
}

#define set_heap(idx,he)		\
  do {					\
    if (flags)				\
      set_idx (he, idx);		\
    heap [idx] = he;			\
  } while (0)

static int
cmp_nv (SV *a, SV *b, void *cmp_data)
{
  a = sv_first (a);
  b = sv_first (b);

  return SvNV (a) > SvNV (b);
}

static int
cmp_sv (SV *a, SV *b, void *cmp_data)
{
  a = sv_first (a);
  b = sv_first (b);

  return sv_cmp (a, b) > 0;
}

static int
cmp_custom (SV *a, SV *b, void *cmp_data)
{
  dCMP_CALL (cmp_data);

  GvSV (PL_firstgv ) = a;
  GvSV (PL_secondgv) = b;

  MULTICALL;

  if (SvTRUE (ERRSV))
    croak (NULL);

  {
    dSP;
    return TOPi > 0;
  }
}

/*****************************************************************************/

typedef int (*f_cmp)(SV *a, SV *b, void *cmp_data);

static AV *
array (SV *ref)
{
  if (SvROK (ref)
      && SvTYPE (SvRV (ref)) == SVt_PVAV
      && !SvTIED_mg (SvRV (ref), PERL_MAGIC_tied))
    return (AV *)SvRV (ref);

  croak ("argument 'heap' must be a (non-tied) array");
}

#define gt(a,b) cmp ((a), (b), cmp_data)

/*****************************************************************************/

/* away from the root */
static void
downheap (AV *av, f_cmp cmp, void *cmp_data, int N, int k, int flags)
{
  SV **heap = AvARRAY (av);
  SV *he = heap [k];

  for (;;)
    {
      int c = (k << 1) + 1;

      if (c >= N)
        break;

      c += c + 1 < N && gt (heap [c], heap [c + 1])
           ? 1 : 0;

      if (!(gt (he, heap [c])))
        break;

      set_heap (k, heap [c]);

      k = c;
    }

  set_heap (k, he);
}

/* towards the root */
static void
upheap (AV *av, f_cmp cmp, void *cmp_data, int k, int flags)
{
  SV **heap = AvARRAY (av);
  SV *he = heap [k];

  while (k)
    {
      int p = (k - 1) >> 1;

      if (!(gt (heap [p], he)))
        break;

      set_heap (k, heap [p]);
      k = p;
    }

  set_heap (k, he);
}

/* move an element suitably so it is in a correct place */
static void
adjustheap (AV *av, f_cmp cmp, void *cmp_data, int N, int k, int flags)
{
  SV **heap = AvARRAY (av);

  if (k > 0 && !gt (heap [k], heap [(k - 1) >> 1]))
    upheap (av, cmp, cmp_data, k, flags);
  else
    downheap (av, cmp, cmp_data, N, k, flags);
}

/*****************************************************************************/

static void
make_heap (AV *av, f_cmp cmp, void *cmp_data, int flags)
{
  int i, len = AvFILLp (av);

  /* do not use floyds algorithm, as I expect the simpler and more cache-efficient */
  /* upheap is actually faster */
  for (i = 0; i <= len; ++i)
    upheap (av, cmp, cmp_data, i, flags);
}

static void
push_heap (AV *av, f_cmp cmp, void *cmp_data, SV **elems, int nelems, int flags)
{
  int i;

  av_extend (av, AvFILLp (av) + nelems);

  /* we do it in two steps, as the perl cmp function might copy the stack */
  for (i = 0; i < nelems; ++i)
    AvARRAY (av)[++AvFILLp (av)] = newSVsv (elems [i]);

  for (i = 0; i < nelems; ++i)
    upheap (av, cmp, cmp_data, AvFILLp (av) - i, flags);
}

static SV *
pop_heap (AV *av, f_cmp cmp, void *cmp_data, int flags)
{
  int len = AvFILLp (av);

  if (len < 0)
    return &PL_sv_undef;
  else if (len == 0)
    return av_pop (av);
  else
    {
      SV *top = av_pop (av);
      SV *result = AvARRAY (av)[0];
      AvARRAY (av)[0] = top;
      downheap (av, cmp, cmp_data, len, 0, flags);
      return result;
    }
}

static SV *
splice_heap (AV *av, f_cmp cmp, void *cmp_data, int idx, int flags)
{
  int len = AvFILLp (av);

  if (idx < 0 || idx > len)
    return &PL_sv_undef;
  else if (idx == len)
    return av_pop (av); /* the last element */
  else
    {
      SV *top = av_pop (av);
      SV *result = AvARRAY (av)[idx];
      AvARRAY (av)[idx] = top;
      adjustheap (av, cmp, cmp_data, len, idx, flags);
      return result;
    }
}

static void
adjust_heap (AV *av, f_cmp cmp, void *cmp_data, int idx, int flags)
{
  int len = AvFILLp (av);

  if (idx > len)
    croak ("Array::Heap::adjust_heap: index out of array bounds");

  adjustheap (av, cmp, cmp_data, len + 1, idx, flags);
}

#line 312 "Heap.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 456 "Heap.c"

XS_EUPXS(XS_Array__Heap_make_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_make_heap)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	heap = ST(0)
;
#line 310 "Heap.xs"
        make_heap (array (heap), cmp_nv, 0, ix);
#line 470 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_make_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_make_heap_lex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	heap = ST(0)
;
#line 316 "Heap.xs"
        make_heap (array (heap), cmp_sv, 0, 0);
#line 487 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_make_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_make_heap_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cmp, heap");
    {
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
#line 322 "Heap.xs"
{
        dCMP;
        CMP_PUSH (cmp);
        make_heap (array (heap), cmp_custom, cmp_data, 0);
        CMP_POP;
}
#line 511 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_push_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_push_heap)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "heap, ...");
    {
	SV *	heap = ST(0)
;
#line 335 "Heap.xs"
        push_heap (array (heap), cmp_nv, 0, &(ST(1)), items - 1, ix);
#line 529 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_push_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_push_heap_lex)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "heap, ...");
    {
	SV *	heap = ST(0)
;
#line 341 "Heap.xs"
        push_heap (array (heap), cmp_sv, 0, &(ST(1)), items - 1, 0);
#line 546 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_push_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_push_heap_cmp)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "cmp, heap, ...");
    {
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
#line 347 "Heap.xs"
{
	SV **st_2 = &(ST(2)); /* multicall.h uses PUSHSTACK */
        dCMP;
        CMP_PUSH (cmp);
        push_heap (array (heap), cmp_custom, cmp_data, st_2, items - 2, 0);
        CMP_POP;
}
#line 571 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_pop_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_pop_heap)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
#line 361 "Heap.xs"
        RETVAL = pop_heap (array (heap), cmp_nv, 0, ix);
#line 590 "Heap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap_pop_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_pop_heap_lex)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "heap");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
#line 369 "Heap.xs"
        RETVAL = pop_heap (array (heap), cmp_sv, 0, 0);
#line 610 "Heap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap_pop_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_pop_heap_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "cmp, heap");
    {
	SV *	RETVAL;
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
#line 377 "Heap.xs"
{
        dCMP;
        CMP_PUSH (cmp);
        RETVAL = pop_heap (array (heap), cmp_custom, cmp_data, 0);
        CMP_POP;
}
#line 637 "Heap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap_splice_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_splice_heap)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "heap, idx");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
	int	idx = (int)SvIV(ST(1))
;
#line 392 "Heap.xs"
        RETVAL = splice_heap (array (heap), cmp_nv, 0, idx, ix);
#line 660 "Heap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap_splice_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_splice_heap_lex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "heap, idx");
    {
	SV *	RETVAL;
	SV *	heap = ST(0)
;
	int	idx = (int)SvIV(ST(1))
;
#line 400 "Heap.xs"
        RETVAL = splice_heap (array (heap), cmp_sv, 0, idx, 0);
#line 682 "Heap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap_splice_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_splice_heap_cmp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cmp, heap, idx");
    {
	SV *	RETVAL;
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
	int	idx = (int)SvIV(ST(2))
;
#line 408 "Heap.xs"
{
        dCMP;
        CMP_PUSH (cmp);
        RETVAL = splice_heap (array (heap), cmp_custom, cmp_data, idx, 0);
        CMP_POP;
}
#line 711 "Heap.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Array__Heap_adjust_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_adjust_heap)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "heap, idx");
    {
	SV *	heap = ST(0)
;
	int	idx = (int)SvIV(ST(1))
;
#line 423 "Heap.xs"
        adjust_heap (array (heap), cmp_nv, 0, idx, ix);
#line 733 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_adjust_heap_lex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_adjust_heap_lex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "heap, idx");
    {
	SV *	heap = ST(0)
;
	int	idx = (int)SvIV(ST(1))
;
#line 429 "Heap.xs"
        adjust_heap (array (heap), cmp_sv, 0, idx, 0);
#line 752 "Heap.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Array__Heap_adjust_heap_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Array__Heap_adjust_heap_cmp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cmp, heap, idx");
    {
	SV *	cmp = ST(0)
;
	SV *	heap = ST(1)
;
	int	idx = (int)SvIV(ST(2))
;
#line 435 "Heap.xs"
{
        dCMP;
        CMP_PUSH (cmp);
        adjust_heap (array (heap), cmp_custom, cmp_data, idx, 0);
        CMP_POP;
}
#line 778 "Heap.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Array__Heap); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Array__Heap)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        cv = newXSproto_portable("Array::Heap::make_heap", XS_Array__Heap_make_heap, file, "\\@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Array::Heap::make_heap_idx", XS_Array__Heap_make_heap, file, "\\@");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Array::Heap::make_heap_lex", XS_Array__Heap_make_heap_lex, file, "\\@");
        (void)newXSproto_portable("Array::Heap::make_heap_cmp", XS_Array__Heap_make_heap_cmp, file, "&\\@");
        cv = newXSproto_portable("Array::Heap::push_heap", XS_Array__Heap_push_heap, file, "\\@@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Array::Heap::push_heap_idx", XS_Array__Heap_push_heap, file, "\\@@");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Array::Heap::push_heap_lex", XS_Array__Heap_push_heap_lex, file, "\\@@");
        (void)newXSproto_portable("Array::Heap::push_heap_cmp", XS_Array__Heap_push_heap_cmp, file, "&\\@@");
        cv = newXSproto_portable("Array::Heap::pop_heap", XS_Array__Heap_pop_heap, file, "\\@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Array::Heap::pop_heap_idx", XS_Array__Heap_pop_heap, file, "\\@");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Array::Heap::pop_heap_lex", XS_Array__Heap_pop_heap_lex, file, "\\@");
        (void)newXSproto_portable("Array::Heap::pop_heap_cmp", XS_Array__Heap_pop_heap_cmp, file, "&\\@");
        cv = newXSproto_portable("Array::Heap::splice_heap", XS_Array__Heap_splice_heap, file, "\\@$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Array::Heap::splice_heap_idx", XS_Array__Heap_splice_heap, file, "\\@$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Array::Heap::splice_heap_lex", XS_Array__Heap_splice_heap_lex, file, "\\@$");
        (void)newXSproto_portable("Array::Heap::splice_heap_cmp", XS_Array__Heap_splice_heap_cmp, file, "&\\@$");
        cv = newXSproto_portable("Array::Heap::adjust_heap", XS_Array__Heap_adjust_heap, file, "\\@$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Array::Heap::adjust_heap_idx", XS_Array__Heap_adjust_heap, file, "\\@$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("Array::Heap::adjust_heap_lex", XS_Array__Heap_adjust_heap_lex, file, "\\@$");
        (void)newXSproto_portable("Array::Heap::adjust_heap_cmp", XS_Array__Heap_adjust_heap_cmp, file, "&\\@$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
